
_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;forum.c,53 :: 		void Interrupt() {
;forum.c,54 :: 		if (INTF_bit && INTE_bit){                             // PORTB0 external interrupt
	BTFSS      INTF_bit+0, BitPos(INTF_bit+0)
	GOTO       L_Interrupt2
	BTFSS      INTE_bit+0, BitPos(INTE_bit+0)
	GOTO       L_Interrupt2
L__Interrupt40:
;forum.c,55 :: 		INTF_bit = 0;                                      // reset interrupt
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
;forum.c,56 :: 		if(nec_state != 0){
	MOVF       _nec_state+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_Interrupt3
;forum.c,57 :: 		timer_value = (TMR1H << 8) + TMR1L;            // Store Timer1 value
	MOVF       TMR1H+0, 0
	MOVWF      _timer_value+1
	CLRF       _timer_value+0
	MOVF       TMR1L+0, 0
	ADDWF      _timer_value+0, 1
	BTFSC      STATUS+0, 0
	INCF       _timer_value+1, 1
;forum.c,58 :: 		TMR1H = 0;                                     // Reset Timer1
	CLRF       TMR1H+0
;forum.c,59 :: 		TMR1L = 0;
	CLRF       TMR1L+0
;forum.c,60 :: 		}
L_Interrupt3:
;forum.c,61 :: 		switch(nec_state){
	GOTO       L_Interrupt4
;forum.c,62 :: 		case 0 :                                         // Start receiving IR data (we're at the beginning of 9ms pulse)
L_Interrupt6:
;forum.c,63 :: 		TMR1H = 0;                                     // Reset Timer1
	CLRF       TMR1H+0
;forum.c,64 :: 		TMR1L = 0;
	CLRF       TMR1L+0
;forum.c,65 :: 		TMR1ON_bit = 1;                                // Enable Timer1
	BSF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;forum.c,66 :: 		nec_state = 1;                                 // Next state: end of 9ms pulse (start of 4.5ms space)
	MOVLW      1
	MOVWF      _nec_state+0
;forum.c,67 :: 		bit_count = 0;
	CLRF       _bit_count+0
;forum.c,68 :: 		PORTC = 0;
	CLRF       PORTC+0
;forum.c,69 :: 		INTEDG_bit = 1;                                // next Interrupt rising edge
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;forum.c,70 :: 		break;
	GOTO       L_Interrupt5
;forum.c,71 :: 		case 1 :                                         // End of 9ms pulse
L_Interrupt7:
;forum.c,73 :: 		if((timer_value > 9500) || (timer_value < 8500)){         // Invalid interval ==> stop decoding and reset
	MOVF       _timer_value+1, 0
	SUBLW      37
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt43
	MOVF       _timer_value+0, 0
	SUBLW      28
L__Interrupt43:
	BTFSS      STATUS+0, 0
	GOTO       L__Interrupt39
	MOVLW      33
	SUBWF      _timer_value+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt44
	MOVLW      52
	SUBWF      _timer_value+0, 0
L__Interrupt44:
	BTFSS      STATUS+0, 0
	GOTO       L__Interrupt39
	GOTO       L_Interrupt10
L__Interrupt39:
;forum.c,74 :: 		nec_state = 0;                             // Reset decoding process
	CLRF       _nec_state+0
;forum.c,75 :: 		TMR1ON_bit = 0;                            // Disable Timer1
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;forum.c,76 :: 		}
	GOTO       L_Interrupt11
L_Interrupt10:
;forum.c,78 :: 		nec_state = 2;                             // Next state: end of 4.5ms space (start of 562s pulse)
	MOVLW      2
	MOVWF      _nec_state+0
;forum.c,79 :: 		INTEDG_bit = 0;                            // next Interrupt falling edge
	BCF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;forum.c,80 :: 		}
L_Interrupt11:
;forum.c,81 :: 		break;
	GOTO       L_Interrupt5
;forum.c,82 :: 		case 2 :                                         // End of 4.5ms space
L_Interrupt12:
;forum.c,83 :: 		nec_code = 0;                                  // clear out all data bits when header found
	CLRF       _nec_code+0
	CLRF       _nec_code+1
	CLRF       _nec_code+2
	CLRF       _nec_code+3
;forum.c,84 :: 		if((timer_value > 5000) || (timer_value < 4000)){
	MOVF       _timer_value+1, 0
	SUBLW      19
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt45
	MOVF       _timer_value+0, 0
	SUBLW      136
L__Interrupt45:
	BTFSS      STATUS+0, 0
	GOTO       L__Interrupt38
	MOVLW      15
	SUBWF      _timer_value+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt46
	MOVLW      160
	SUBWF      _timer_value+0, 0
L__Interrupt46:
	BTFSS      STATUS+0, 0
	GOTO       L__Interrupt38
	GOTO       L_Interrupt15
L__Interrupt38:
;forum.c,85 :: 		nec_state = 0;                               // Reset decoding process
	CLRF       _nec_state+0
;forum.c,86 :: 		TMR1ON_bit = 0;                              // Disable Timer1
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;forum.c,87 :: 		}
	GOTO       L_Interrupt16
L_Interrupt15:
;forum.c,89 :: 		nec_state = 3;                             // Next state: end of 562s pulse (start of 562s or 1687s space)
	MOVLW      3
	MOVWF      _nec_state+0
;forum.c,90 :: 		INTEDG_bit = 1;                            // next Interrupt rising edge
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;forum.c,91 :: 		}
L_Interrupt16:
;forum.c,92 :: 		break;
	GOTO       L_Interrupt5
;forum.c,93 :: 		case 3 :                                         // End of 562s pulse
L_Interrupt17:
;forum.c,94 :: 		if((timer_value > 700) || (timer_value < 400)){           // Invalid interval ==> stop decoding and reset
	MOVF       _timer_value+1, 0
	SUBLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt47
	MOVF       _timer_value+0, 0
	SUBLW      188
L__Interrupt47:
	BTFSS      STATUS+0, 0
	GOTO       L__Interrupt37
	MOVLW      1
	SUBWF      _timer_value+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt48
	MOVLW      144
	SUBWF      _timer_value+0, 0
L__Interrupt48:
	BTFSS      STATUS+0, 0
	GOTO       L__Interrupt37
	GOTO       L_Interrupt20
L__Interrupt37:
;forum.c,95 :: 		TMR1ON_bit = 0;                            // Disable Timer1
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;forum.c,96 :: 		nec_state = 0;                             // Reset decoding process
	CLRF       _nec_state+0
;forum.c,97 :: 		}
	GOTO       L_Interrupt21
L_Interrupt20:
;forum.c,99 :: 		nec_state = 4;                             // Next state: end of 562s or 1687s space
	MOVLW      4
	MOVWF      _nec_state+0
;forum.c,100 :: 		INTEDG_bit = 0;                            // next Interrupt falling edge
	BCF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;forum.c,101 :: 		}
L_Interrupt21:
;forum.c,102 :: 		break;
	GOTO       L_Interrupt5
;forum.c,103 :: 		case 4 :                                         // End of 562s or 1687s space
L_Interrupt22:
;forum.c,104 :: 		if((timer_value > 2800) || (timer_value < 400)){           // Time interval invalid ==> stop decoding
	MOVF       _timer_value+1, 0
	SUBLW      10
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt49
	MOVF       _timer_value+0, 0
	SUBLW      240
L__Interrupt49:
	BTFSS      STATUS+0, 0
	GOTO       L__Interrupt36
	MOVLW      1
	SUBWF      _timer_value+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt50
	MOVLW      144
	SUBWF      _timer_value+0, 0
L__Interrupt50:
	BTFSS      STATUS+0, 0
	GOTO       L__Interrupt36
	GOTO       L_Interrupt25
L__Interrupt36:
;forum.c,105 :: 		TMR1ON_bit = 0;                            // Disable Timer1
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;forum.c,106 :: 		nec_state = 0;                             // Reset decoding process
	CLRF       _nec_state+0
;forum.c,107 :: 		break;
	GOTO       L_Interrupt5
;forum.c,108 :: 		}
L_Interrupt25:
;forum.c,109 :: 		if( timer_value > 800){                       // If space width > 0.6ms (short space)
	MOVF       _timer_value+1, 0
	SUBLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt51
	MOVF       _timer_value+0, 0
	SUBLW      32
L__Interrupt51:
	BTFSC      STATUS+0, 0
	GOTO       L_Interrupt26
;forum.c,110 :: 		nec_code |= 1UL << (bit_count);          // Write 1 to bit (31 - i)
	MOVF       _bit_count+0, 0
	MOVWF      R4+0
	MOVLW      1
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      0
	MOVWF      R0+2
	MOVLW      0
	MOVWF      R0+3
	MOVF       R4+0, 0
L__Interrupt52:
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt53
	RLF        R0+0, 1
	RLF        R0+1, 1
	RLF        R0+2, 1
	RLF        R0+3, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__Interrupt52
L__Interrupt53:
	MOVF       R0+0, 0
	IORWF      _nec_code+0, 1
	MOVF       R0+1, 0
	IORWF      _nec_code+1, 1
	MOVF       R0+2, 0
	IORWF      _nec_code+2, 1
	MOVF       R0+3, 0
	IORWF      _nec_code+3, 1
;forum.c,111 :: 		}
	GOTO       L_Interrupt27
L_Interrupt26:
;forum.c,114 :: 		}
L_Interrupt27:
;forum.c,115 :: 		bit_count++;
	INCF       _bit_count+0, 1
;forum.c,116 :: 		if(bit_count > 31){                            // If all bits are received
	MOVF       _bit_count+0, 0
	SUBLW      31
	BTFSC      STATUS+0, 0
	GOTO       L_Interrupt28
;forum.c,117 :: 		nec_ok = 1;                                // Decoding process OK
	BSF        _nec_ok+0, BitPos(_nec_ok+0)
;forum.c,118 :: 		INTE_bit = 0;                              // Disable PORTB external interrupt
	BCF        INTE_bit+0, BitPos(INTE_bit+0)
;forum.c,119 :: 		return;
	GOTO       L__Interrupt42
;forum.c,120 :: 		}
L_Interrupt28:
;forum.c,121 :: 		nec_state = 3;                                 // Next state: end of 562s pulse (start of 562s or 1687s space)
	MOVLW      3
	MOVWF      _nec_state+0
;forum.c,122 :: 		INTEDG_bit = 1;                                // next Interrupt rising edge
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;forum.c,123 :: 		break;
	GOTO       L_Interrupt5
;forum.c,124 :: 		}
L_Interrupt4:
	MOVF       _nec_state+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_Interrupt6
	MOVF       _nec_state+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_Interrupt7
	MOVF       _nec_state+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_Interrupt12
	MOVF       _nec_state+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_Interrupt17
	MOVF       _nec_state+0, 0
	XORLW      4
	BTFSC      STATUS+0, 2
	GOTO       L_Interrupt22
L_Interrupt5:
;forum.c,125 :: 		}
L_Interrupt2:
;forum.c,126 :: 		if (TMR1IF_bit){                                       // Timer1 ISR - time-out after 65 milliseconds
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L_Interrupt29
;forum.c,127 :: 		TMR1IF_bit = 0;                                    // Clear Timer1 overflow flag bit
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;forum.c,128 :: 		nec_state = 0;                                     // Reset decoding process
	CLRF       _nec_state+0
;forum.c,129 :: 		TMR1ON_bit = 0;                                    // Disable Timer1
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;forum.c,130 :: 		}
L_Interrupt29:
;forum.c,131 :: 		}
L_end_Interrupt:
L__Interrupt42:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_main:

;forum.c,133 :: 		void main() {
;forum.c,134 :: 		OSCCON = 0X70;                                         // 8 MHz internal oscillator
	MOVLW      112
	MOVWF      OSCCON+0
;forum.c,135 :: 		TRISB = 0x01;                                          // RB0 input for IR receiver, rest output
	MOVLW      1
	MOVWF      TRISB+0
;forum.c,136 :: 		TRISD = 0x00;                                          // all output
	CLRF       TRISD+0
;forum.c,137 :: 		ANSEL = 0x00;                                          // all digital
	CLRF       ANSEL+0
;forum.c,138 :: 		ANSELH = 0;                                            // Configure all PORTB pins as digital
	CLRF       ANSELH+0
;forum.c,139 :: 		nec_ok = 0;                                            // initialise
	BCF        _nec_ok+0, BitPos(_nec_ok+0)
;forum.c,140 :: 		nec_state = 0;                                         // initial state
	CLRF       _nec_state+0
;forum.c,141 :: 		Lcd_Init();                                            // Initialize LCD module
	CALL       _Lcd_Init+0
;forum.c,142 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);                              // cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;forum.c,143 :: 		Lcd_Cmd(_LCD_CLEAR);                                   // clear LCD
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;forum.c,144 :: 		TMR1IF_bit = 0;                                        // Clear Timer1 overflow interrupt flag bit
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;forum.c,145 :: 		TMR1IE_bit = 1;                                        // Enable Timer1 overflow interrupt
	BSF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;forum.c,146 :: 		T1CON = 0x10;                                          // Set Timer1 clock source to internal with 1:2 prescaler (Timer1 clock = 1MHz)
	MOVLW      16
	MOVWF      T1CON+0
;forum.c,147 :: 		INTCON = 0x80;                                         // global Interrupt enable
	MOVLW      128
	MOVWF      INTCON+0
;forum.c,148 :: 		OPTION_REG = 0x80;                                     // pull-ups disabled, ext INT falling edge
	MOVLW      128
	MOVWF      OPTION_REG+0
;forum.c,149 :: 		Lcd_Out(1,1,"NEC decode IR");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_forum+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;forum.c,150 :: 		Lcd_Out(2,1, "16 Aug 2019");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr2_forum+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;forum.c,151 :: 		Delay_ms(2000);                                        // allow time to see first message
	MOVLW      21
	MOVWF      R11+0
	MOVLW      75
	MOVWF      R12+0
	MOVLW      190
	MOVWF      R13+0
L_main30:
	DECFSZ     R13+0, 1
	GOTO       L_main30
	DECFSZ     R12+0, 1
	GOTO       L_main30
	DECFSZ     R11+0, 1
	GOTO       L_main30
	NOP
;forum.c,152 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;forum.c,153 :: 		Lcd_Out(1, 1, "Address:0x0000");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr3_forum+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;forum.c,154 :: 		Lcd_Out(2, 1, "Com:0x00 In:0x00");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr4_forum+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;forum.c,155 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main31:
	DECFSZ     R13+0, 1
	GOTO       L_main31
	DECFSZ     R12+0, 1
	GOTO       L_main31
	DECFSZ     R11+0, 1
	GOTO       L_main31
	NOP
	NOP
;forum.c,156 :: 		INTE_bit = 1;                                          // Enable PORTB external Interrupt
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
;forum.c,157 :: 		INTF_bit = 0;                                          // clear possible old interrupt
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
;forum.c,159 :: 		while(1) {
L_main32:
;forum.c,160 :: 		while(!nec_ok);                                    // Wait until NEC code received
L_main34:
	BTFSC      _nec_ok+0, BitPos(_nec_ok+0)
	GOTO       L_main35
	GOTO       L_main34
L_main35:
;forum.c,161 :: 		nec_ok = 0;                                        // Reset decoding process
	BCF        _nec_ok+0, BitPos(_nec_ok+0)
;forum.c,162 :: 		nec_state = 0;
	CLRF       _nec_state+0
;forum.c,163 :: 		TMR1ON_bit = 0;                                    // Disable Timer1
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;forum.c,164 :: 		addressh = nec_code;                               // swap address bytes around ...
	MOVF       _nec_code+0, 0
	MOVWF      _addressh+0
;forum.c,165 :: 		addressl = nec_code >> 8;
	MOVF       _nec_code+1, 0
	MOVWF      R7+0
	MOVF       _nec_code+2, 0
	MOVWF      R7+1
	MOVF       _nec_code+3, 0
	MOVWF      R7+2
	CLRF       R7+3
	MOVF       R7+0, 0
	MOVWF      _addressl+0
;forum.c,166 :: 		address = (addressh << 8) + addressl;              // ... then re-combine
	MOVF       _nec_code+0, 0
	MOVWF      R0+1
	CLRF       R0+0
	MOVF       R7+0, 0
	ADDWF      R0+0, 0
	MOVWF      R5+0
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R5+1
	MOVF       R5+0, 0
	MOVWF      _address+0
	MOVF       R5+1, 0
	MOVWF      _address+1
;forum.c,167 :: 		command = nec_code >> 16;
	MOVF       _nec_code+2, 0
	MOVWF      R0+0
	MOVF       _nec_code+3, 0
	MOVWF      R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVF       R0+0, 0
	MOVWF      _command+0
;forum.c,168 :: 		inv_command = nec_code >> 24;
	MOVF       _nec_code+3, 0
	MOVWF      R0+0
	CLRF       R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVF       R0+0, 0
	MOVWF      _inv_command+0
;forum.c,169 :: 		IntToHex(address, text);                           // Save address in string text with hex format
	MOVF       R5+0, 0
	MOVWF      FARG_IntToHex_input+0
	MOVF       R5+1, 0
	MOVWF      FARG_IntToHex_input+1
	MOVLW      _text+0
	MOVWF      FARG_IntToHex_output+0
	CALL       _IntToHex+0
;forum.c,170 :: 		Lcd_Out(1, 11, text);                              // Display address
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      11
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _text+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;forum.c,171 :: 		ByteToHex(command, text);                          // Save command in string text with hex format
	MOVF       _command+0, 0
	MOVWF      FARG_ByteToHex_input+0
	MOVLW      _text+0
	MOVWF      FARG_ByteToHex_output+0
	CALL       _ByteToHex+0
;forum.c,172 :: 		Lcd_Out(2, 7, text);                               // Display command
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _text+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;forum.c,173 :: 		ByteToHex(inv_command, text);                      // Save inverted command in string text with hex format
	MOVF       _inv_command+0, 0
	MOVWF      FARG_ByteToHex_input+0
	MOVLW      _text+0
	MOVWF      FARG_ByteToHex_output+0
	CALL       _ByteToHex+0
;forum.c,174 :: 		Lcd_Out(2, 15, text);                              // Display inverted command
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      15
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _text+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;forum.c,175 :: 		INTE_bit = 1;                                      // Enable PORTB external interrupt
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
;forum.c,176 :: 		}
	GOTO       L_main32
;forum.c,177 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
