#line 1 "C:/PIC/MikroC/PIC16/PIC16F887/forum/forum.c"
#line 27 "C:/PIC/MikroC/PIC16/PIC16F887/forum/forum.c"
sbit LCD_RS at RD1_bit;
sbit LCD_EN at RD2_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD1_bit;
sbit LCD_EN_Direction at TRISD2_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;


bit nec_ok;
char text[5];
unsigned short nec_state;
unsigned short command;
unsigned short inv_command;
unsigned short bit_count;
unsigned short addressh;
unsigned short addressl;
unsigned int address;
unsigned int timer_value;
unsigned long nec_code;

void Interrupt() {
 if (INTF_bit && INTE_bit){
 INTF_bit = 0;
 if(nec_state != 0){
 timer_value = (TMR1H << 8) + TMR1L;
 TMR1H = 0;
 TMR1L = 0;
 }
 switch(nec_state){
 case 0 :
 TMR1H = 0;
 TMR1L = 0;
 TMR1ON_bit = 1;
 nec_state = 1;
 bit_count = 0;
 PORTC = 0;
 INTEDG_bit = 1;
 break;
 case 1 :

 if((timer_value > 9500) || (timer_value < 8500)){
 nec_state = 0;
 TMR1ON_bit = 0;
 }
 else{
 nec_state = 2;
 INTEDG_bit = 0;
 }
 break;
 case 2 :
 nec_code = 0;
 if((timer_value > 5000) || (timer_value < 4000)){
 nec_state = 0;
 TMR1ON_bit = 0;
 }
 else{
 nec_state = 3;
 INTEDG_bit = 1;
 }
 break;
 case 3 :
 if((timer_value > 700) || (timer_value < 400)){
 TMR1ON_bit = 0;
 nec_state = 0;
 }
 else{
 nec_state = 4;
 INTEDG_bit = 0;
 }
 break;
 case 4 :
 if((timer_value > 2800) || (timer_value < 400)){
 TMR1ON_bit = 0;
 nec_state = 0;
 break;
 }
 if( timer_value > 800){
 nec_code |= 1UL << (bit_count);
 }
 else{

 }
 bit_count++;
 if(bit_count > 31){
 nec_ok = 1;
 INTE_bit = 0;
 return;
 }
 nec_state = 3;
 INTEDG_bit = 1;
 break;
 }
 }
 if (TMR1IF_bit){
 TMR1IF_bit = 0;
 nec_state = 0;
 TMR1ON_bit = 0;
 }
}

void main() {
 OSCCON = 0X70;
 TRISB = 0x01;
 TRISD = 0x00;
 ANSEL = 0x00;
 ANSELH = 0;
 nec_ok = 0;
 nec_state = 0;
 Lcd_Init();
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_CLEAR);
 TMR1IF_bit = 0;
 TMR1IE_bit = 1;
 T1CON = 0x10;
 INTCON = 0x80;
 OPTION_REG = 0x80;
 Lcd_Out(1,1,"NEC decode IR");
 Lcd_Out(2,1, "16 Aug 2019");
 Delay_ms(2000);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, "Address:0x0000");
 Lcd_Out(2, 1, "Com:0x00 In:0x00");
 Delay_ms(1000);
 INTE_bit = 1;
 INTF_bit = 0;

 while(1) {
 while(!nec_ok);
 nec_ok = 0;
 nec_state = 0;
 TMR1ON_bit = 0;
 addressh = nec_code;
 addressl = nec_code >> 8;
 address = (addressh << 8) + addressl;
 command = nec_code >> 16;
 inv_command = nec_code >> 24;
 IntToHex(address, text);
 Lcd_Out(1, 11, text);
 ByteToHex(command, text);
 Lcd_Out(2, 7, text);
 ByteToHex(inv_command, text);
 Lcd_Out(2, 15, text);
 INTE_bit = 1;
 }
}
